#ifndef UOBJECT_H_
#define UOBJECT_H_

#include <glib-object.h>
#include "upkg.h"
#include "avl.h"

#define U_OBJECT_TYPE u_object_get_type()
#define U_OBJECT(obj) \
	G_TYPE_CHECK_INSTANCE_CAST(obj, U_OBJECT_TYPE, UObject)
#define U_OBJECT_CLASS(class) \
	G_TYPE_CHECK_CLASS_CAST(class, U_OBJECT_TYPE, UObjectClass)
#define IS_U_OBJECT(obj) \
	G_TYPE_CHECK_INSTANCE_TYPE(obj, U_OBJECT_TYPE)
#define IS_U_OBJECT_CLASS(class) \
	G_TYPE_CHECK_CLASS_TYPE(class, U_OBJECT_TYPE, UObjectClass)
#define U_OBJECT_GET_CLASS(obj) \
	G_TYPE_INSTANCE_GET_CLASS(obj, U_OBJECT_TYPE, UObjectClass)

typedef struct UObject      UObject;
typedef struct UObjectClass UObjectClass;

struct UObject {
	GObject parent;
};

struct UObjectClass {
	GObjectClass parent;

	int (*deserialize)(UObject *obj, struct upkg_file *f);
};

GType u_object_get_type(void);

const GValue *u_object_get_property(UObject *obj, const char *name);
void u_object_set_property(UObject *obj, const char *name, const GValue *val);

int u_object_deserialize(GObject *obj, struct upkg_file *f);

#endif
